<div *ngIf="!is_expand" class="row mb-1">
    <!-- <div class="col-sm-4 ml-4"></div> -->
    <div class="col-sm-9 pr-0" style="margin-left: 0%;">
        <div class="card border-0 box-shadow-none"
             style="margin-left: 3.7rem;margin-right: 0.3rem; background-color: transparent;">
            <div (click)="toggle_entity(null, null);"
                 class="CardList card-header collapsed-card-border d-flex pr-0 align-items-center card-shadow bg-white  border-radius-10">
                <div class="card-header-title dashboard-tile-title cursor custom-mouseover" style="font-size: 18px;">
                    <span class="mr-2"><i
                            class="las la-angle-right f-20"></i></span><span>{{flow_child.view_name}}</span></div>
                <div class="ml-auto btn-group btn-group-xs btn-group-toggle ng-untouched ng-pristine ng-valid mr-2">
                    <div class="ml-1">
                        <!-- <button  class="btn p-1   " >
                         <i  class="las la-ellipsis-v f-20 " style="cursor: default;"></i>
                        </button> -->
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="col-sm-3 pt-4">
        <!-- //right side title for some content  -->
        <p class="f-14"></p>
    </div>
</div>
<div class="col-md-9 position-relative" *ngIf="is_expand">
    <div class="connecting_line_top_expand"
         style="position: absolute;bottom:-75px; right:25px;width:2px;background: #C4C4C4;height: 120px;"></div>
</div>
<div class="col-md-9 position-relative" *ngIf="!is_expand">
    <div class="connecting_line_top_collapsed"
         style="position: absolute;bottom:-75px; right:25px;width:2px;background:#C4C4C4;height: 120px;"></div>
</div>
<div *blockUI="blockUIName;  template: blockTemplate" class="custom-bg-block-ui">
    <div id="flow_container" [hidden]="!is_expand" class="row  mt-3 ml-0 mr-0 flow_container"
         (scroll)="onScroll($event)"
         style="flex-wrap: unset;min-height:400px;padding-left: 3rem;;overflow-x: auto;overflow-y: hidden;padding-bottom: 20px;">
        <!-- <div style="position: absolute; height:510px;background-image:linear-gradient(to right, rgba(246, 246, 246,1),rgba(246, 246, 246,0));left:0;width:70px;z-index: 1087;"></div>
        <div style="position: absolute; height:510px;background-image: linear-gradient(to right, rgba(246, 246, 246,0),rgba(246, 246, 246,1));right:0;width:70px;z-index: 1087;"></div>
         -->
        <div style="position: absolute; height:520px;background-image:linear-gradient(to right, rgba(246, 246, 246,1),rgba(246, 246, 246,0));left:0;width:70px;z-index: 1087;">
            <div>
                <app-hint [id]="'slide-card'" *ngIf="flow_index == 0 && scroll_position.active!='left'"></app-hint>
                <div *ngIf="scroll_position.active!='left'" (click)="scroll_flow('left')" class="slideLeft">
                    <!-- <i class="las la-angle-left" style="font-size: 20px;"></i> -->
                    <img src="../../../assets/imgs/LftArrow.svg">
                </div>
            </div>
        </div>
        <div style="position: absolute; height:520px;background-image: linear-gradient(to right, rgba(246, 246, 246,0),rgba(246, 246, 246,1));right:0;width:70px;z-index: 1087;">
            <div *ngIf="scroll_position.active=='left'" (click)="scroll_flow('center')" class="slideRight">
                <!-- <i class="las la-angle-right" style="font-size: 20px;"></i> -->
                <img src="../../../assets/imgs/LftArrow.svg">
            </div>
        </div>
        <div class="{{scroll_position.class}}">
            <div class="card card-shadow flow-entity-popup border-radius-10" style="min-height: 500px;">
                <div class="card-header with-elements pr-0 card-bb-color popupTable">
                    <!-- don't remove the popuptable css -->
                    <div class="card-header-title dashboard-tile-title cursor " style="max-width: 50% !important;">
                        <span>Data</span></div>
                    <div class="ml-auto btn-group btn-group-xs btn-group-toggle ng-untouched ng-pristine ng-valid mr-2">
                        <div class="ml-1">
                            <button class="btn p-1   " ngbTooltip="Add / Modify data in this card" placement="bottom"
                                    container="body"
                                    (click)="openSettings(add_remove_settings_modal);isCustomActive('Table_addRemove')"
                                    [ngClass]="customActive == 'Table_addRemove' ? 'icon-active' : ''">
                                <i class="las la-plus-square f-20 custom-mouseover"></i></button>
                        </div>
                        <div class="ml-1">
                            <button class="btn p-1" [disabled]="no_data_found" ngbTooltip="View data in full screen"
                                    placement="bottom" container="body"
                                    (click)="fullScreen($event,'table')">
                                <i class="las la-expand f-20 custom-mouseover"></i></button>
                        </div>
                        <div class="ml-1">
                            <button class="btn p-1   " [disabled]="no_data_found"
                                    placement="bottom" container="body" ngbTooltip="Add / Manage calculated fields"
                                    (click)="addCalculatedFieldDialog()">
                                <i class="las la-calculator f-20 custom-mouseover"></i></button>
                        </div>
                        <div ngbDropdown class="ml-1">
                            <button class="btn p-1   hide-arrow" [disabled]="no_data_found"
                                    ngbDropdownToggle
                                    ngbTooltip="Table type" placement="bottom" container="body">
                                <i class="las la-table f-20 custom-mouseover"></i></button>
                            <!-- Dropdown menu -->
                            <div ngbDropdownMenu class="dropdown-menu-right">
                                <!--  [ngClass]="optionType == 'compact' ? 'active': ''" -->
                                <a class="dropdown-item"
                                   [ngClass]="optionType == 'flat' ? 'active': ''"
                                   (click)="switchTableType('flat')">Simple</a>
                                <a class="dropdown-item"
                                   [ngClass]="optionType == 'compact' ? 'active': ''"
                                   (click)="switchTableType('compact')">Pivot
                                    Simple</a>
                                <a class="dropdown-item"
                                   [ngClass]="optionType == 'classic' ? 'active': ''"
                                   (click)="switchTableType('classic')">Pivot
                                    Full</a>
                            </div>
                        </div>
                        <div ngbDropdown class="ml-1">
                            <button class="btn p-1 hide-arrow" [disabled]="no_data_found" ngbDropdownToggle
                                    ngbTooltip="Number formatting & totals"
                                    placement="bottom" container="body">
                                <i class="las la-hashtag f-20 custom-mouseover"></i></button>
                            <div ngbDropdownMenu class="dropdown-menu-right py-2">
                                <a class="dropdown-item" (click)="addFormatCellsDialog()">Format Cells</a>
                                <a class="dropdown-item" (click)="changeTotalStatus('showGrandTotals')">
                                    <span>Add Grand Total</span>
                                    <i *ngIf="current_pc?.options.grid?.showGrandTotals!='off'"
                                       class="las la-check fa-lg ml-2"></i>
                                </a>
                                <a class="dropdown-item" (click)="changeTotalStatus('showTotals')">
                                    <span >Add Sub Total</span>
                                    <i *ngIf="current_pc?.options.grid?.showTotals!='off'"
                                       class="las la-check fa-lg ml-2"></i>
                                </a>
                            </div>
                        </div>
                        <div ngbDropdown class="ml-1">
                            <button class="btn p-1 hide-arrow" [disabled]="no_data_found" ngbDropdownToggle
                                    ngbTooltip="Conditional color formatting"
                                    placement="bottom" container="body">
                                <i class="las la-greater-than-equal custom-mouseover"></i></button>
                            <div ngbDropdownMenu class="dropdown-menu-right">
                                <a class="dropdown-item" (click)="openConditionalFormattingConfirm()">Conditional
                                    Formatting</a>
                                <a class="dropdown-item" (click)="openHeatmapConfirm(heatmap_confirm, autoHeatMap)">Auto
                                    Heatmap</a>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="card-body p-0" [hidden]="no_data_found">
                    <div class="w-100 d-flex align-items-center" style="height: auto;overflow-x:auto;">

                        <div class="d-inline" *ngFor="let report_filter of custom_report_filters;">
                            <div class="ml-1 m-1 px-2 py-1 values-align row form-group group-label datePick1"
                                 style="float: left;">
                                <label class="label label-style pl-0 pb-1">{{report_filter.caption}}</label>
                                <span (click)="open_report_Filter(report_filter.uniqueName)"
                                      class="m-0 badge-title border-0 custom-badge-style"
                                      style="cursor:pointer;padding-left: 0 !important">
                          <span class="badge" style="cursor:pointer;">Multiple Items</span>
                        </span>
                            </div>
                        </div>

                        <div class="d-inline" *ngFor="let option of viewFilterdata">
                            <div class="ml-1 px-2 mr-1 py-1 values-align row form-group group-label datePick1 my-1"
                                 *ngIf="!option.datefield ">
                                <label class="label label-style pl-0 pb-1">{{option.name}}</label>


                                <span *ngIf="!option.datefield"
                                      (click)="openFilterAppliedModal(option, filterModal, { windowClass: 'modal-fill-in modal-md animate' })"
                                      class="m-0 badge-title border-0 custom-badge-style"
                                      style="cursor:pointer;padding-left: 0 !important">
                          <span class="badge" style="cursor:pointer;">{{option.display_value}}</span>
                    
                        </span>


                                <ng-template #filterModal let-c="close" let-d="dismiss">
                                    <div class="modal-header">
                                        <h5 class="modal-title">
                                            {{option.name}}
                                        </h5>
                                    </div>
                                    <div class="modal-body filter-popup-div p-0">
                                        <div class="loader-container" *ngIf="filterLoader" style="padding-top:40%;">
                                            <svg class="entityLoader" xmlns="http://www.w3.org/2000/svg"
                                                 xmlns:xlink="http://www.w3.org/1999/xlink"
                                                 style="margin: auto; background: transparent none repeat scroll 0% 0%; display: block;"
                                                 viewBox="0 0 100 100" preserveAspectRatio="xMidYMid">
                                                <circle cx="27.5" cy="57.5" r="5" class="entityBlue">
                                                    <animate attributeName="cy" calcMode="spline"
                                                             keySplines="0 0.5 0.5 1;0.5 0 1 0.5;0.5 0.5 0.5 0.5"
                                                             repeatCount="indefinite" values="57.5;42.5;57.5;57.5"
                                                             keyTimes="0;0.3;0.6;1" dur="1s" begin="-0.6s">
                                                    </animate>
                                                </circle>
                                                <circle cx="42.5" cy="57.5" r="5" class="entityBlue">
                                                    <animate attributeName="cy" calcMode="spline"
                                                             keySplines="0 0.5 0.5 1;0.5 0 1 0.5;0.5 0.5 0.5 0.5"
                                                             repeatCount="indefinite" values="57.5;42.5;57.5;57.5"
                                                             keyTimes="0;0.3;0.6;1" dur="1s"
                                                             begin="-0.44999999999999996s"></animate>
                                                </circle>
                                                <circle cx="57.5" cy="57.5" r="5" class="entityBlue">
                                                    <animate attributeName="cy" calcMode="spline"
                                                             keySplines="0 0.5 0.5 1;0.5 0 1 0.5;0.5 0.5 0.5 0.5"
                                                             repeatCount="indefinite" values="57.5;42.5;57.5;57.5"
                                                             keyTimes="0;0.3;0.6;1" dur="1s" begin="-0.3s">
                                                    </animate>
                                                </circle>
                                                <circle cx="72.5" cy="57.5" r="5" class="entityBlue">
                                                    <animate attributeName="cy" calcMode="spline"
                                                             keySplines="0 0.5 0.5 1;0.5 0 1 0.5;0.5 0.5 0.5 0.5"
                                                             repeatCount="indefinite" values="57.5;42.5;57.5;57.5"
                                                             keyTimes="0;0.3;0.6;1" dur="1s" begin="-0.15s">
                                                    </animate>
                                                </circle>
                                            </svg>
                                        </div>
                                        <div *ngIf="!option.datefield" class="p-3">
                                            <div>
                                                <input class="form-control user-input-material custom-text-color"
                                                       type='text' placeholder='Search'
                                                       (keyup)='searchFilterValues($event.target.value.toLowerCase())'
                                                       [(ngModel)]="filterSearchText">
                                                <li class="list-group-item" style="border:none;">
                                                    <label class="custom-control custom-checkbox mt-2">
                                                        <input class="custom-control-input" type="checkbox"
                                                               (change)="selectAll(option)"
                                                               [(ngModel)]="isSelectAll">
                                                        <span class="custom-control-label">Select
                                      All</span>
                                                    </label>
                                                </li>
                                            </div>
                                            <div class="filter-list" appInfinitescroll
                                                 (scrolled)="updateScrollPos($event, option)">
                                                <ul class="list-group material m-0">
                                                    <li class="list-group-item"
                                                        *ngFor="let value of filterArray; let i=index;">
                                                        <label class="custom-control custom-checkbox">
                                                            <input class="custom-control-input" type="checkbox"
                                                                   (change)="changeSelectedStatus($event,i)"
                                                                   [checked]="value.selected">
                                                            <span class="custom-control-label">{{value.value}}</span>
                                                        </label>
                                                    </li>
                                                </ul>
                                            </div>
                                        </div>

                                    </div>
                                    <div class="modal-footer">
                                        <div class="app-filter-btn">
                                            <button type="button" class="btn btn-default device-btn"
                                                    (click)="d('Cross click')">Cancel
                                            </button>
                                            <button type="button" class="btn btn-primary device-btn"
                                                    (click)="d('Cross click'); applyFilter(option)">Apply
                                            </button>
                                        </div>
                                    </div>
                                </ng-template>

                            </div>
                        </div>

                    </div>

                    <fm-pivot #flowpivotcontainer [width]="'100%'" [height]="'438px'" [toolbar]="true"
                              [licenseKey]="'Z7TE-102510-6Z0345-61393B-585P5Q-3X053C-5F5P3O-1B2038-6T164M-6F1V6W-0K61'"
                              (beforetoolbarcreated)="customTableToolbar($event)"
                              (reportchange)="pivot_config_change()"
                              (loadingdata)="loadingData()"
                              (update)="onReportChange($event)"
                              [customizeContextMenu]="customizeFlexmonsterContextMenu.bind(this)"
                              [customizeCell]="customizeCellFunction.bind(this)">
                    </fm-pivot>
                </div>
                <!-- If no data found -->
                <div *ngIf="no_data_found === true" class="text-center nodata">
                    <span class="f-18 text-gray77">No data found</span>
                </div>
            </div>
        </div>
        <div class="col-sm-9">
            <div class="card card-shadow border-radius-10" style="min-height:500px;">
                <div class="card-header with-elements pr-0 align-items-center card-bb-color">
                    <div (click)="toggle_entity(null, null);"
                         class="card-header-title dashboard-tile-title cursor custom-mouseover"><span class="mr-2"><i
                            class="las la-angle-down f-20"></i></span><span>{{flow_child.view_name}}</span>
                        <!-- <span class="ml-2 v-middle"><i  class="las  la-question-circle f-20"></i></span> -->
                    </div>
                    <div class="ml-auto btn-group btn-group-xs btn-group-toggle ng-untouched ng-pristine ng-valid mr-2">
                        <div class="ml-1">
                            <button class="btn p-1"
                                    (click)="openSettings(add_remove_settings_modal);isCustomActive('addRemove')"
                                    [ngClass]="customActive == 'addRemove' ? 'icon-active' : ''"
                                    placement="bottom" container="body" ngbTooltip="Add / Modify data in this card">
                                <i class="las la-plus-square f-20 custom-mouseover"></i></button>
                        </div>
                        <div class="ml-1">
                            <button class="btn p-1" [disabled]="no_data_found"
                                    ngbTooltip="View visualization in full screen" placement="bottom" container="body"
                                    (click)="fullScreen(flowchart_id+'_card', 'flow_chart');isCustomActive('fullScreen')"
                                    [ngClass]="fullScreen == 'chartType' ? 'icon-active' : ''">
                                <i class="las la-expand f-20 custom-mouseover"></i></button>
                        </div>
                        <div class="ml-1 flow-entity-popup">
                            <button class="btn p-1 ngb-popover-dark" placement="bottom" [ngbPopover]="popFilterContent"
                                    triggers="mouseenter:mouseleave" [popoverTitle]="popFilterTitle"
                                    (click)="openChartFilter(chart_filter_modal);isCustomActive('chartFilter')"
                                    [ngClass]="customActive == 'chartFilter' ? 'icon-active' : ''">
                                <i class="las la-filter f-20 custom-mouseover"></i>
                                <span *ngIf="applied_filters.length === 0" class="badge indicator plus">+</span>
                                <span *ngIf="applied_filters.length > 0"
                                      class="badge indicator num">{{applied_filters.length}}</span>
                            </button>
                        </div>
                        <div class="ml-1">
                            <button class="btn p-1" [disabled]="no_data_found"
                                    ngbTooltip="Change visualization for this card" placement="bottom" container="body"
                                    (click)="chooseChartType(chart_modal);isCustomActive('chartType')"
                                    [ngClass]="customActive == 'chartType' ? 'icon-active' : ''">
                                <i class="las la-chart-bar f-20 custom-mouseover"></i></button>
                        </div>
                        <div class="ml-1">
                            <button class="btn p-1" ngbTooltip="Understand the data behind this card" placement="bottom"
                                    container="body"
                                    (click)="toggleHelpInfo();" [ngClass]="isHelpIconActive ? '' : 'icon-active'">
                                <i class="f-20"
                                   [ngClass]="isHelpIconActive ? 'las la-question-circle custom-mouseover' : 'fas fa-question-circle blue-text'"></i>
                            </button>
                        </div>
                        <!-- More -->

                        <div ngbDropdown [placement]="'bottom-right'" class="ml-1">
                            <button ngbDropdownToggle class="btn p-1 borderless md-btn-flat hide-arrow"
                                    ngbTooltip="More actions" placement="bottom" container="body">
                                <i class="las la-ellipsis-v f-20 custom-mouseover"></i></button>
                            <div ngbDropdownMenu [class.dropdown-menu-right]="!isRTL" class="mt-3 py-2"
                                 style="box-shadow: 0px 3px 10px 1px #7d7d7d5c !important;">
                                <a class="dropdown-item" href="javascript:void(0)"
                                   (click)="openDialog(add_to_flow_model, { windowClass: 'modal-fill-in modal-md modal-md animate', backdrop : 'static',keyboard : false })">
                                    <i class="las la-thumbtack fa-lg"></i><span class="ml-2">Add to Document</span></a>
                                <a class="dropdown-item" href="javascript:void(0)"
                                   (click)="openEditDialog(edit_Model, { windowClass: 'modal-fill-in modal-md modal-md animate', backdrop : 'static',keyboard : false })">
                                    <i class="las la-edit fa-lg"></i><span class="ml-2">Edit</span></a>
                                <a class="dropdown-item" href="javascript:void(0)"
                                   (click)="removeCard(removeAlert_Model)">
                                    <i class="las la-trash-alt fa-lg"></i><span class="ml-2">Remove Card</span></a>
                            </div>
                        </div>

                        <!-- More -->
                    </div>
                </div>
                <div class="card-body pb-0 px-0" style="min-height: 400px;"
                     [ngClass]="{'card-body-map': selected_chart_type=='map'}">
                    <div class="d-flex" *ngIf="!no_data_found" id="{{flowchart_id+'_card'}}">
                        <!-- <button class="map-reset" (click)="resetMapZoom()" placement="bottom" container="body" ngbTooltip="Reset View"  *ngIf="highmap_instance.zoomed"><i class="fas fa-redo-alt"></i></button> -->
                        <button class="map-reset" (click)="leafletService.resetMapZoom()" container="body"
                                title="Reset View" *ngIf="leafletService.isZoomed"><i class="fas fa-redo-alt f-10"></i>
                        </button>
                        <div id="{{flowchart_id}}" class="hc_div"
                             [ngClass]="selected_chart_type=='map' && map_data.length>1 ? 'col-sm-10 p-0 map_chart':'col-sm-12 p-0'"></div>
                        <div *ngIf="selected_chart_type=='map' && map_data.length>1" class="col-md-2 overflow-items"
                             [perfectScrollbar]>
                            <ng-container *ngFor="let sub_data of map_data;">
                                <div (click)="leafletService.formatMapData(sub_data); selected_map = sub_data;"
                                     class="mb-3 daily-data-tab"
                                     [ngClass]="leafletService.selected_map.current_name == sub_data.current_name?'active':''">
                                    <div class="card-body p-3">
                                        <div class="align-items-center">
                                            <div class="f-16 fw-700">{{sub_data.current_name}}</div>
                                            <div class="f-14 gray text-muted">{{sub_data.current_value}}</div>
                                        </div>
                                    </div>
                                </div>
                            </ng-container>
                        </div>
                    </div>
                    <!-- If no data found -->
                    <div *ngIf="no_data_found === true" class="text-center nodata">
                        <span class="f-18 text-gray77">No data found</span>
                    </div>
                </div>
            </div>


            <!--start  help info -->
            <div class="d-flex slideDiv" [@slideInOut]="animationState" style="background-color: #E9E9E9 !important;">
                <div style="width:60%;" class="pl-2 mr-4 pb-3">
                    <ngb-tabset class="nav-tabs-top  flowtab ">
                        <ngb-tab title="Data Definition">
                            <ng-template ngbTabContent>
                                <div class="card-body" style="height: 240px;overflow-y: auto;" [perfectScrollbar]>
                                    <div class="f-16 mb-2">
                                        <span class="fw-700">Sort Condition</span>
                                        <span class="pl-2">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class="fw-700">Sort Condition</span>
                                        <span class="pl-2">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class="fw-700">Sort Condition</span>
                                        <span class="pl-2">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class="fw-700">Sort Condition</span>
                                        <span class="pl-2">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class="fw-700">Sort Condition</span>
                                        <span class="pl-2">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class="fw-700">Sort Condition</span>
                                        <span class="pl-2">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class="fw-700">Sort Condition</span>
                                        <span class="pl-2">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class="fw-700">Sort Condition</span>
                                        <span class="pl-2">Descending by Gross Sales</span>
                                    </div>
                                </div>
                            </ng-template>
                        </ngb-tab>
                        <ngb-tab title="Data Lineage">
                            <ng-template ngbTabContent>
                                <div class="card-body">
                                    <p class="f-14">Some Content....</p>
                                </div>
                            </ng-template>
                        </ngb-tab>
                        <ngb-tab title="Data Validation">
                            <ng-template ngbTabContent>
                                <div class="card-body">
                                    <p class="f-14">Some Content....</p>
                                </div>
                            </ng-template>
                        </ngb-tab>
                    </ngb-tabset>
                </div>
                <div style="width:40%;" class="pl-2 pr-2 pb-3">
                    <!--<ngb-tabset class="nav-tabs-top  flowtabnext">
                        <ngb-tab title="How did we get these results">
                            <ng-template ngbTabContent>
                                <div class="card-body" style="height: 240px;overflow-y: auto;" [perfectScrollbar]>
                                    <div class="f-16 mb-2">
                                        <span class=" fw-700">Sort Condition</span>
                                        <span class="float-right">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class=" fw-700">Sort Condition</span>
                                        <span class="float-right">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class=" fw-700">Sort Condition</span>
                                        <span class="float-right">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class=" fw-700">Sort Condition</span>
                                        <span class="float-right">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class=" fw-700">Sort Condition</span>
                                        <span class="float-right">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class=" fw-700">Sort Condition</span>
                                        <span class="float-right">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class=" fw-700">Sort Condition</span>
                                        <span class="float-right">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class=" fw-700">Sort Condition</span>
                                        <span class="float-right">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class=" fw-700">Sort Condition</span>
                                        <span class="float-right">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class=" fw-700">Sort Condition</span>
                                        <span class="float-right">Descending by Gross Sales</span>
                                    </div>
                                    <div class="f-16 mb-2">
                                        <span class=" fw-700">Sort Condition</span>
                                        <span class="float-right">Descending by Gross Sales</span>
                                    </div>
                                </div>
                            </ng-template>
                        </ngb-tab>


                    </ngb-tabset>-->
                </div>
            </div>
            <!-- End help info     -->
        </div>
        <div class="col-sm-3">
            <app-hint [id]="'summary'"></app-hint>
            <ngb-tabset class="nav-tabs-top flowtab">
                <ngb-tab *ngFor="let tab of flow_child?.tabs">
                    <ng-template ngbTabTitle>
                        <span class="tab-title text-capitalize">{{tab.name}}</span>
                    </ng-template>
                    <ng-template ngbTabContent>
                        <div class="card-body pl-0 flow_cardbody" [perfectScrollbar]>
                            <div class="f-14" [innerHTML]='tab.description | safeHtml'></div>
                        </div>
                    </ng-template>
                </ngb-tab>
            </ngb-tabset>

            <!-- <div style="min-height: 487px;" *ngIf="!flow_child.edit_content"></div> -->
        </div>
    </div>
    <div class="row">

        <div class="col-sm-9 ml-5">
            <!-- start switch icons -->
            <div class="mx-auto text-center switching-tab-mt">
                <div *ngIf="is_expand">
    <span class="ml-1">
        <button class="btn p-1   " (click)="scroll_flow('left')">
            <app-hint [id]="'data-view'" *ngIf="flow_index == 0" (click)="$event.stopPropagation()"></app-hint>
          <div>
            <i class="fas fa-circle f-5 border-100"
               [ngClass]="scroll_position.active=='left'?'blue-dot':'gray-dot'"></i>
           </div>
<div>
  <i class="las la-table f-20" [ngClass]="scroll_position.active=='left'?'':'gray-text'" ngbTooltip="Data View"
     placement="bottom" container="body"></i>
</div>
        </button>
        </span>
                    <span class="ml-1">
        <button class="btn p-1   " (click)="scroll_flow('center')">
          <div>
            <i class="fas fa-circle f-5 border-100 blue-dot"></i>
           </div>
<div>
  <i class="las la-chart-bar f-20" ngbTooltip="Visualization" placement="bottom" container="body"></i>
</div>
        </button>
    </span>
                    <span class="ml-1">
        <button class="btn p-1   " (click)="scroll_flow('right')">
          <div>
            <i class="fas fa-circle f-5 border-100"
               [ngClass]="scroll_position.active=='right' || scroll_position.active=='center' ? 'blue-dot':'gray-dot'"></i>
          </div>
<div>
  <i class="las la-lightbulb f-20" ngbTooltip="Insights" placement="bottom" container="body"
     [ngClass]="scroll_position.active=='right' || scroll_position.active=='center' ?'':'gray-text'"></i>
</div>
         </button>
    </span>
                </div>
            </div>
            <!-- end switch icons -->
            <!-- start connected des -->
            <div class="mx-auto" *ngIf="flow_child?.run_sales_analysis" style="height: 37px;">
                <div class="ml-1 d-flex align-items-center float-right my-1" style="padding-right:4rem;">
                    <div class="f-16 pr-3">Did you want to run a <span
                            class="measure-text blue-text">Sales Analysis</span> instead ?
                    </div>
                    <div class="conneted-dot"></div>
                    <div class="connecting_line_footer" *ngIf="is_expand"
                         style="position: absolute; top: -21px; width: 2px; background: #C4C4C4; height: 57px;right: 79px;"></div>
                    <div class="connecting_line_footer_colapsed" *ngIf="!is_expand"
                         style="position: absolute; top: -5px; width: 2px; background: #C4C4C4; height: 45px;right: 79px;"></div>
                </div>
            </div>
            <!-- end connected des -->
        </div>
        <div class="col-md-3"></div>
    </div>
</div>
<div class="col-md-9 position-relative" *ngIf="is_expand">
    <div class="connecting_line_expand_bottom"
         style="position: absolute;bottom:-75px; right:25px;width:2px;background: #C4C4C4;height: 120px;"></div>
</div>
<div class="col-md-9 position-relative" *ngIf="!is_expand">
    <div class="connecting_line_bottom"
         style="position: absolute;bottom:-8em; right:25px;width:2px;background: #C4C4C4;height: 120px;"></div>
</div>

<ng-template #chart_modal let-c="close" let-d="dismiss">
    <chart-modal [selected_chart_type]="selected_chart_type" (chart_event)="chart_callback($event)"></chart-modal>
</ng-template>
<!-- Settings Modal --dhinesh -->
<ng-template #add_remove_settings_modal let-c="close" let-d="dismiss">
    <chart-settings [resultData]="flow_result.hsresult" (settings_event)="settings_callback($event)"></chart-settings>
</ng-template>
<!-- Filter modal -- dhinesh -->
<ng-template #chart_filter_modal let-c="close" let-d="dismiss">
    <chart-filter [resultData]="flow_result.hsresult" (filter_event)="chart_filter_callback($event)"></chart-filter>
</ng-template>


<!-- start add to flow -->
<ng-template #add_to_flow_model let-c="close" let-d="dismiss">
    <div class="modal-header">
        <h5 class="modal-title">
            <i class="las la-search fa-lg mr-2" style="transform: rotate(-90deg);"></i>
            <span class="text-muted">Add to</span>
            <br>
        </h5>
        <button type="button" class="close" (click)="d('Cross click');shareClear();">&times;</button>
    </div>
    <div class="modal-body">
        <div class="row no-gutters" style="height:300px; overflow-y:scroll;overflow: hidden;" [perfectScrollbar]>
            <div class="form-row col-md-12">
                <div class="form-group col border-top-0">
                    <label class="custom-control custom-checkbox">
                        <input class="custom-control-input ng-untouched ng-pristine ng-valid" type="checkbox">
                        <span class="custom-control-label">Sales Analysis for last month </span></label></div>
            </div>
            <div class="form-row col-md-12">
                <div class="form-group col border-top-0">
                    <label class="custom-control custom-checkbox">
                        <input class="custom-control-input ng-untouched ng-pristine ng-valid" type="checkbox">
                        <span class="custom-control-label">Sales for lunch in San Jose</span></label></div>
            </div>
            <div class="form-row col-md-12">
                <div class="form-group col border-top-0">
                    <label class="custom-control custom-checkbox">
                        <input class="custom-control-input ng-untouched ng-pristine ng-valid" type="checkbox">
                        <span class="custom-control-label">Avocado Sales for lunch last year</span></label></div>
            </div>
            <div class="form-row col-md-12">
                <div class="form-group col border-top-0">
                    <label class="custom-control custom-checkbox">
                        <input class="custom-control-input ng-untouched ng-pristine ng-valid" type="checkbox">
                        <span class="custom-control-label">Total Labor Saving last month </span></label></div>
            </div>
            <div class="form-row col-md-12">
                <div class="form-group col border-top-0">
                    <label class="custom-control custom-checkbox">
                        <input class="custom-control-input ng-untouched ng-pristine ng-valid" type="checkbox">
                        <span class="custom-control-label">Total Revenue YOY</span></label></div>
            </div>
            <div class="form-row col-md-12">
                <div class="form-group col border-top-0">
                    <label class="custom-control custom-checkbox">
                        <input class="custom-control-input ng-untouched ng-pristine ng-valid" type="checkbox">
                        <span class="custom-control-label">Sales Analysis for last month</span></label></div>
            </div>
        </div>

    </div>

    <div class="modal-footer" style="justify-content: flex-start;">
        <div class="float-left">
            <i class="las la-plus fa-lg mr-2"></i> <span class="f-16">Create a new document</span></div>
    </div>
</ng-template>
<!-- end add to flow -->

<!-- start edit model -->
<ng-template #edit_Model let-c="close" let-d="dismiss">
    <flow-edit [resultData]="flow_child" (edit_event)="edit_callback($event)"></flow-edit>
</ng-template>
<!-- REmove alert -->
<ng-template #removeAlert_Model let-c="close" let-d="dismiss" class="modal fade-scale">
    <div class="modal-header">
        <h2 class="modal-title confirm-dialog"><i class="fa fa-exclamation-circle" aria-hidden="true"></i>
            <span class="font-weight-light">Confirmation</span>
        </h2>
        <button type="button" class="close" (click)="d('Cross click')">&times;</button>
    </div>

    <div class="modal-body">
        <p class="mb-0 unpin-text">Are you sure to remove the card?</p>
    </div>

    <div class="modal-footer">
        <button type="button" class="btn btn-primary btn-material" (click)="callBackToRemove();c('Close click')">Yes
        </button>
        <button type="button" class="btn btn-default" (click)="c('Close click')">No</button>
    </div>
</ng-template>
<!-- end edit model -->
<ng-template #blockTemplate>
    <div class="block-ui-template custom-bg-block-ui mb-3">
        <div class="app-splash-screen ">
            <div class="new-app-splash-screen-content text-center">
                <!-- <img src="../../assets/img/card-hx-loader.svg" class="card-loader-svg"> -->
                <svg class="entityLoader" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"
                     style="margin: auto; background: transparent none repeat scroll 0% 0%; display: block;"
                     viewBox="0 0 100 100" preserveAspectRatio="xMidYMid">
                    <circle cx="27.5" cy="57.5" r="5" class="entityBlue">
                        <animate attributeName="cy" calcMode="spline"
                                 keySplines="0 0.5 0.5 1;0.5 0 1 0.5;0.5 0.5 0.5 0.5" repeatCount="indefinite"
                                 values="57.5;42.5;57.5;57.5" keyTimes="0;0.3;0.6;1" dur="1s" begin="-0.6s"></animate>
                    </circle>
                    <circle cx="42.5" cy="57.5" r="5" class="entityBlue">
                        <animate attributeName="cy" calcMode="spline"
                                 keySplines="0 0.5 0.5 1;0.5 0 1 0.5;0.5 0.5 0.5 0.5" repeatCount="indefinite"
                                 values="57.5;42.5;57.5;57.5" keyTimes="0;0.3;0.6;1" dur="1s"
                                 begin="-0.44999999999999996s"></animate>
                    </circle>
                    <circle cx="57.5" cy="57.5" r="5" class="entityBlue">
                        <animate attributeName="cy" calcMode="spline"
                                 keySplines="0 0.5 0.5 1;0.5 0 1 0.5;0.5 0.5 0.5 0.5" repeatCount="indefinite"
                                 values="57.5;42.5;57.5;57.5" keyTimes="0;0.3;0.6;1" dur="1s" begin="-0.3s"></animate>
                    </circle>
                    <circle cx="72.5" cy="57.5" r="5" class="entityBlue">
                        <animate attributeName="cy" calcMode="spline"
                                 keySplines="0 0.5 0.5 1;0.5 0 1 0.5;0.5 0.5 0.5 0.5" repeatCount="indefinite"
                                 values="57.5;42.5;57.5;57.5" keyTimes="0;0.3;0.6;1" dur="1s" begin="-0.15s"></animate>
                    </circle>
                </svg>
                <span class="loading-text-material">
        </span>
            </div>
        </div>
    </div>
</ng-template>
<!-- start auto heat map model -->
<ng-template #autoHeatMap let-c="close" let-d="dismiss">
    <heatmap [heatmap_config]="grid_config.heatmap" (heatmap_event)="heatmap_callback($event)"></heatmap>
</ng-template>
<!-- End auto heat map model -->

<!-- start heatmap_confirm -->
<ng-template #heatmap_confirm let-c="close" let-d="dismiss">
    <div class="modal-header">
        <h2 class="modal-title confirm-dialog"><i class="fa fa-exclamation-circle" aria-hidden="true"></i>
            <span class="font-weight-light">Confirmation</span>
        </h2>
        <button type="button" class="close" (click)="d('Cross click')">&times;</button>
    </div>
    <div class="modal-body">
        <div class="row no-gutters">
            <div class="col-md-12 text-center ">
                <label class="f-14 mb-0">You already have existing conditional formatting defined. Turning on Auto
                    Heatmap</label>
                <label class="f-14 "> will override existing definitions. Would you like to proceed?</label>
            </div>
        </div>
    </div>
    <div class="modal-footer">
        <button type="button" class="btn btn-default" (click)="c('Close click');shareClear();">No</button>
        <button type="button" class="btn btn-primary btn-material" (click)="openHeatmapDialog(autoHeatMap)">Yes</button>
    </div>
</ng-template>
<!-- End heatmap_confirm -->
<!-- start conditional_confirm -->
<ng-template #conditional_confirm let-c="close" let-d="dismiss">
    <div class="modal-header">
        <h2 class="modal-title confirm-dialog"><i class="fa fa-exclamation-circle" aria-hidden="true"></i>
            <span class="font-weight-light">Confirmation</span>
        </h2>
        <button type="button" class="close" (click)="d('Cross click')">&times;</button>
    </div>
    <div class="modal-body">
        <div class="row no-gutters">
            <div class="col-md-12 text-center ">
                <label class="f-14 mb-0">You already have Auto Heatmap enabled. Turning on conditional
                    formatting</label>
                <label class="f-14 "> will override existing definitions. Would you like to proceed?</label>
            </div>
        </div>
    </div>
    <div class="modal-footer">
        <button type="button" class="btn btn-default" (click)="c('Close click');shareClear();">No</button>
        <button type="button" class="btn btn-primary btn-material"
                (click)="openConditionalFormattingDialog();setDirtyFlag();">Yes
        </button>
    </div>
</ng-template>
<!-- End conditional_confirm -->


<ng-template #popFilterContent>
    <div class="mb-1">
        <p>Global Filters Applied :</p>
    </div>
    <div *ngFor="let filter of view_filtered_data">
        <div class="dis-flex">
            <span>{{filter?.object_display}} : &nbsp;</span>
            <span *ngIf="filter.object_type === 'fromdate' || filter.object_type === 'todate'">{{filter?.object_id}}</span>
            <span *ngIf="filter?.object_type !== 'fromdate' && filter?.object_type !== 'todate'">
                <span *ngFor="let f of filter.object_id; index as i">
                  <span *ngIf="i==0">
                    {{f}}
                  </span>
                  <span *ngIf="i>0">,&nbsp; {{ f}} </span>
                </span>
            </span>
        </div>
    </div>
    <div style="color:#aaa" *ngIf="view_filtered_data.length === 0">No global filters applied</div>
    <hr/>
    <div class="mt-1">
        <p>Local Filters Applied :</p>

    </div>
    <div *ngFor="let filter of applied_filters">
        <div class="dis-flex">
            <span>{{filter?.object_display}} : &nbsp;</span>
            <span>
                <span *ngFor="let f of filter.object_id; index as i">
                  <span *ngIf="i==0">
                    {{f}}
                  </span>
                  <span *ngIf="i>0">,&nbsp; {{ f}} </span>
                </span>
            </span>
        </div>
    </div>
    <div style="color:#aaa" *ngIf="applied_filters.length === 0">No local filters applied</div>
</ng-template>
